const as integer MAX_TECLAS = 11

type controle
	private:
		key_state as ubyte ptr
		
		tecla (0 to MAX_TECLAS - 1) as integer
		last_tecla (0 to MAX_TECLAS - 1) as integer
		
	public:	
		const as integer DOWN = 0
		const as integer PRESSED = 1
		const as integer K_UP = 0
		const as integer K_DOWN = 1
		const as integer K_LEFT = 2
		const as integer K_RIGHT = 3
		const as integer K_ESCOLHE = 4
		const as integer K_RETORNA = 5
		const as integer K_PAUSA = 6
		const as integer K_BOOST = 7
		const as integer K_3D = 8
		const as integer K_SFX = 9
		const as integer K_MUSICA = 10
			
		declare function confereTecla (i as integer, estado as integer) as _bool_
		declare sub atualiza
		declare sub esperaTecla
end type

dim shared kev as controle

'-----------------------------------------------------------------------
function controle.confereTecla (i as integer, estado as integer) as _bool_
	if (estado = DOWN) or (estado = PRESSED and last_tecla(i) = false) then
		return tecla(i)
	else
		return false
	end if
end function

sub controle.atualiza
	dim as integer i, botoes
	
	'copia estado anterior
	for i = 0 to MAX_TECLAS - 1
		last_tecla(i) = tecla(i)
	next
	
	'atualiza key state
	SDL_PumpEvents
	key_state = SDL_GetKeyState(NULL)
		
	'mapeia sdl para vetor interno
	tecla(K_UP)			= key_state[SDLK_UP]
	tecla(K_DOWN)		= key_state[SDLK_DOWN]
	tecla(K_LEFT)		= key_state[SDLK_LEFT] 
	tecla(K_RIGHT)		= key_state[SDLK_RIGHT]
	tecla(K_ESCOLHE)	= key_state[SDLK_RETURN]
	tecla(K_RETORNA)	= key_state[SDLK_ESCAPE]
	tecla(K_PAUSA)		= key_state[SDLK_P] or key_state[SDLK_PAUSE]
	tecla(K_BOOST)		= key_state[SDLK_LSHIFT] or key_state[SDLK_RSHIFT]
	
	tecla(K_3D)			= key_state[SDLK_F1]
	tecla(K_SFX)		= key_state[SDLK_F2]
	tecla(K_MUSICA)		= key_state[SDLK_F3]
end sub

sub controle.esperaTecla
	do
		'whatever
	loop until confereTecla(K_ESCOLHE, PRESSED) or confereTecla(K_RETORNA, PRESSED)
end sub
