declare function angadd (ang1 as double, ang2 as double) as double
declare function angdif (ang1 as double, ang2 as double) as double
declare sub hsva (hue as double, s as double, v as double, a as double)
declare sub setPalA (cor as hsvVal, a as double)
declare sub hsv (hue as double, s as double, v as double)
declare sub setPal (cor as hsvVal)

'-----------------------------------------------------------------------
'soma dois ângulos com wrap
function angadd (ang1 as double, ang2 as double) as double
	ang1 = ang1 + ang2
	
	if ang1 > (2 * pi) then ang1 = ang1 - (2 * pi)
	if ang1 < 0 then ang1 = ang1 + (2 * pi)
	
	return ang1
end function

'calcula a distância entre dois ângulos
function angdif (ang1 as double, ang2 as double) as double
	dim as double norma
	norma = abs(ang1 - ang2)
	
	if norma <= pi then return norma
	return (2 * pi) - norma
end function

'passa HSV como RGB
sub hsva (hue as double, s as double, v as double, a as double) 'h 0-360 | s 0-1 | v 0-1
	'Altera saturação do 3D
	if _3D_ON then s = s * 0.25
	
	'monocromático
	if s = 0 then
		glColor4f v, v, v, a
		exit sub
	end if
	
	'converte
	dim as double r, g, b, f, p, q, t
	
	hue = hue / 60
	f = frac(hue)
	p = v * (1 - s)
	q = v * (1 - s * f)
	t = v * (1 - s * (1 - f))
	
	select case fix(hue) 'hue - f
		case 0
			r = v
			g = t
			b = p
		case 1
			r = q
			g = v
			b = p
		case 2
			r = p
			g = v
			b = t
		case 3
			r = p
			g = q
			b = v
		case 4
			r = t
			g = p
			b = v
		case else
			r = v
			g = p
			b = q
	end select
	
	glColor4f r, g, b, a
end sub

sub setPalA (cor as hsvVal, a as double)
	hsva cor.h, cor.s, cor.v, a
end sub

sub hsv (hue as double, s as double, v as double)
	hsva hue, s, v, 1
end sub

sub setPal (cor as hsvVal)
	hsv cor.h, cor.s, cor.v
end sub
